#include <iostream>

using namespace std;

#include <queue>

//donada una seqüència acabada per '.' que conté caràcters
//alfanumèrics i el símbol '#', aquest símbol indica una petició que
//està formada per un enter no negatiu n i un 0 o un 1. Si és 0 la
//petició és d'escriure n dígits (dels rebuts a la sequència, sense
//comptar les peticions), i si és 1 és d'escriure n caràcters
//alfabètics. Les peticions han de ser satisfetes per ordre d'arribada
//en quan s'han rebut prou dígits o caràcters alfanumèrics.


void printpref(queue<char> &c, int m){
  //m>=c.size()
  while (m!=0) {
    cout << c.front();
    c.pop();
    --m;
  }
  cout << endl;
}

int main(){
  queue <char> cd; //cua de dígits rebuts pendents d'escriure
  queue <char> ca; //cua de caràcters alfabètics rebuts pendents d'escriure
  queue <int> cpd; //cua de peticions de dígits 
  queue <int> cpa; //cua de peticions de caràcters alfabètics
                   //per les peticions només guardem la quantitat de
                   //caràcters demanats
  char e;
  cin >> e;
  while ( e!='.' ) {
    if (e=='#') { 
      int m,k; cin>>m>>k;
      if (k==0) cpd.push(m);
      else cpa.push(m);
    }
    else if (e>='0' and e<= '9') 
      cd.push(e);
    else ca.push(e);

    if (!cpd.empty() and cd.size()>=cpd.front()) {
      printpref(cd,cpd.front());
      cpd.pop();
    }

    if (!cpa.empty() and ca.size()>=cpa.front()) {
      printpref(ca,cpa.front());
      cpa.pop();
    }
    cin >> e;
  }
}
